
pc_get_global_fault_status = function()
    local status = ngx.shared.pc_status 
    key = "pc:g:fault";
    return tonumber(status:get(key)) or 0
end

pc_get_fault_key = function(timestamp)
    if not timestamp then
        timestamp = ngx.time()
    end

    return os.date("fault:minute:%M", timestamp)
end

pc_get_fault_num = function(timestamp)
    local status = ngx.shared.pc_status
    local key = pc_get_fault_key(timestamp)
    return tonumber(status:get(key)) or 0
end

pc_incr_fault_num = function(timestamp)
    local status = ngx.shared.pc_status
    local key = pc_get_fault_key(timestamp)

    if not status:incr(key, 1) then
        status:add(key, 0, 600)
        status:incr(key, 1)
    end
end

