<?php
/**
* rewrite url. html to php
*/
function rewrite($url){
    $pattern = array(
        '/^\/detail\/(\d+).html$/',
    );
    $replace = array(
        '/detail.php?feedid=$1',
    );
    return preg_replace($pattern, $replace, $url);
}

/**
* check valid. some url can not be cached
*/
function checkIgnore($url){
    $keywords = array(
        '/test/',
    );
    foreach($keywords as $keyword){
        if(stripos($url, $keyword) !== false){
            return true;
        }
    }
    return false;
}

/**
* request to varnish
*/
function get($url){
    if(empty($url) || checkIgnore($url)){
        return false;
    }
    $url_info = parse_url($url);
    $url = $url_info["scheme"]."://127.0.0.1:8080";
    if(isset($url_info["path"])){
        $url_path = rewrite($url_info["path"]);
        $url .= $url_path;
    }
    if(isset($url_info["query"])){
	if(strpos($url, "?") === false){
	    $url .= "?".$url_info["query"];	
	}else{
            $url .= "&".$url_info["query"];
	}
    }
    $host = $url_info["host"];
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_HTTPHEADER, array("Host: $host"));
    curl_setopt($ch, CURLOPT_HEADER, true);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_USERAGENT, "crond");
    curl_exec($ch);
    curl_close($ch);
    return true;
}

/**
* parse nginx log to get url
*/
function parseNginxLog(){
    $ret = array();
    $time = strtotime("-1 minutes");
    $year = date("Y", $time);
    $month = date("m", $time);
    $day = date("d", $time);
    $hour = date("H", $time);
    $path = "/home/web/logs/{$year}/{$month}/{$day}/access-{$year}-{$month}-{$day}_{$hour}.log";
    $size = filesize($path);
    $file = fopen($path, "r");
    if(!$file || !$size){
        return $ret;
    }
    $offset = $size > 1000000 ? 1000000: $size;
    fseek($file, 0-$offset, SEEK_END);
    $content = fread($file, $offset);
    $pattern = '/"GET (.*?)[" ]/';
    preg_match_all($pattern, $content, $matchs);
    if(isset($matchs[1])){
        return $matchs[1];
    }
    return $ret;
}
$urls = parseNginxLog();
foreach($urls as $url){
    get($url);
}
get("http://demo.bo56.com/index.php");
?>
